/***ja_libr.h*******************************************/
#ifndef _JA_LIBR_H
#define _JA_LIBR_H

#ifdef OS_LIB
  #define OS_OPTI_SEMT
  #define OS_OPTI_MSGT
  #define OS_OPTI_DELAY
#else
  #include <jacnfg.h>
#endif

#ifndef OS_Lib_Type

  #ifndef OS_MEM_MODEL
    #define OS_MEM_MODEL COMPACT
  #endif

#else

  #define OSL_NOOPT    0x8000L
  #define OSL_TIMER    0x0010L
  #define OSL_EVENT    0x0020L
  #define OSL_TIMEOUT  0x0040L
  #define OSL_NOPRIO   0x0080L
  #define OSL_TIMER16  0x0100L
  #define OSL_MSG16    0x0200L
  #define OSL_SEM16    0x0400L
  #define OSL_SH_LOCK  0x0001L
  #define OSL_EV_FORG  0x0002L
  #define OSL_EV_BACKG 0x0004L
  #define OSL_WORKSPC  0x0008L
  #define OSL_NOIDLE   0x0800L

  #define OSL_COMPACT  4
  #define OSL_SMALL    2
  #define OSL_NORMAL   1
  #define OSL_SMALL_COMPACT  OSL_SMALL + OSL_COMPACT

  #define OS_nt   OSL_NOOPT //OSL_NOIDLE
  #define OS_ntn  OSL_NOOPT + OSL_NOPRIO //OSL_NOIDLE +
  #define OS_ct   OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG
  #define OS_ci   OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG
  #define OS_dt   OSL_NOOPT + OSL_TIMER   + OSL_EV_BACKG
  #define OS_et   OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG
  #define OS_ei   OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_EV_FORG
  #define OS_tt   OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG
  #define OS_ti   OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG
  #define OS_ctn  OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_NOPRIO
  #define OS_cin  OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_NOPRIO
  #define OS_dtn  OSL_NOOPT + OSL_TIMER   + OSL_EV_BACKG  + OSL_NOPRIO
  #define OS_etn  OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_NOPRIO
  #define OS_ein  OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_NOPRIO
  #define OS_ttn  OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_NOPRIO
  #define OS_tin  OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG + OSL_NOPRIO

  #define OS_ct2  OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_MSG16     + OSL_SEM16   + OSL_TIMER16
  #define OS_ci2  OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_MSG16   + OSL_SEM16   + OSL_TIMER16
  #define OS_dt2  OSL_NOOPT + OSL_TIMER   + OSL_EV_BACKG  + OSL_TIMER16
  #define OS_et2  OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_MSG16     + OSL_SEM16     + OSL_TIMER16
  #define OS_ei2  OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_MSG16     + OSL_SEM16   + OSL_TIMER16
  #define OS_tt2  OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_MSG16   + OSL_SEM16   + OSL_TIMER16
  #define OS_ti2  OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG + OSL_MSG16   + OSL_SEM16 + OSL_TIMER16
  #define OS_ctn2 OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_NOPRIO    + OSL_MSG16   + OSL_SEM16   + OSL_TIMER16
  #define OS_cin2 OSL_NOOPT + OSL_TIMER   + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_NOPRIO  + OSL_MSG16   + OSL_SEM16 + OSL_TIMER16
  #define OS_dtn2 OSL_NOOPT + OSL_TIMER   + OSL_EV_BACKG  + OSL_NOPRIO    + OSL_TIMER16
  #define OS_etn2 OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_NOPRIO    + OSL_MSG16     + OSL_SEM16   + OSL_TIMER16
  #define OS_ein2 OSL_NOOPT + OSL_EVENT   + OSL_EV_BACKG  + OSL_EV_FORG   + OSL_NOPRIO    + OSL_MSG16   + OSL_SEM16   + OSL_TIMER16
  #define OS_ttn2 OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_NOPRIO  + OSL_MSG16   + OSL_SEM16 + OSL_TIMER16
  #define OS_tin2 OSL_NOOPT + OSL_TIMEOUT + OSL_TIMER     + OSL_EVENT     + OSL_EV_BACKG  + OSL_EV_FORG + OSL_NOPRIO  + OSL_MSG16 + OSL_SEM16 + OSL_TIMER16

  #undef  OS_USE_PRIO
  #ifndef OS_MAX_PRIO
    #if (OS_Lib_Type & OSL_NOPRIO)
      #define OS_MAX_PRIO 0
    #else
      #define OS_MAX_PRIO 1
      #define OS_USE_PRIO
    #endif
  #else
    #define OS_USE_PRIO
  #endif

  #undef  OS_DELAY_SIZE
  #if   (OS_Lib_Type & OSL_TIMER)
    #if   (OS_Lib_Type & OSL_TIMER16)
      #define OS_DELAY_SIZE 2
    #else
      #define OS_DELAY_SIZE 1
    #endif
  #else
    #define OS_DELAY_SIZE 0
  #endif

  #undef  OS_USE_TIMEOUT
  #if   (OS_Lib_Type & OSL_TIMEOUT)
    #define OS_USE_TIMEOUT
  #endif

  #undef  OS_MSG_CVALIF
  #if   (OS_Lib_Type & OSL_MSG16)
    #define OS_MSG_CVALIF OS_MSG_FAR
  #else
    #define OS_MSG_CVALIF OS_MSG_NEAR
  #endif

  #undef  OS_SEM_SIZE
  #undef  OS_FLAGS_SIZE
  #if   (OS_Lib_Type & OSL_SEM16)
    #define OS_SEM_SIZE 2
    #define OS_FLAGS_SIZE 2
  #else
    #define OS_SEM_SIZE 1
    #define OS_FLAGS_SIZE 1
  #endif

  #ifndef OS_MEM_MODEL
    #ifndef OS_LIB
      #ifdef _PIC14
        #define OS_MEM_MODEL COMPACT // SMALL +
      #else
        #define OS_MEM_MODEL COMPACT
      #endif
    #else
      #if   (OS_LIB == OSL_COMPACT)
        #define OS_MEM_MODEL COMPACT
      #elif (OS_LIB == OSL_SMALL)
        #define OS_MEM_MODEL SMALL
      #elif (OS_LIB == OSL_SMALL + OSL_COMPACT)
        #define OS_MEM_MODEL SMALL + COMPACT
      #elif (OS_LIB == OSL_NORMAL)
        #define OS_MEM_MODEL NORMAL
      #endif
    #endif
  #endif

  #undef OS_SCHED_LOCKED
  #if   (OS_Lib_Type & OSL_SH_LOCK)
    #define OS_SCHED_LOCKED
  #endif

  #undef  OS_USE_IDLE_TASK
  #if   (OS_Lib_Type & OSL_NOIDLE)
  #else
    #define OS_USE_IDLE_TASK
  #endif

  #undef  OS_CALL_COND

  #undef  OS_USE_EV_EVRW
  #undef  OS_PROTECT_ENABLE
  #if   (OS_Lib_Type & OSL_EV_FORG)
    #define OS_PROTECT_ENABLE
    #define OS_USE_EV_EVRW
  #endif

  #if   (OS_Lib_Type & OSL_NOIDLE)
    #define OS_NO_EVENTS
  #endif

  #undef  OS_USE_RESUME
  #define OS_USE_RESUME
  #undef  OS_USE_STOP
  #define OS_USE_STOP
  #undef  OS_USE_TASK_STATUS
  #define OS_USE_TASK_STATUS

  //#undef  OS_USE_BANK2
  //#define OS_USE_BANK2
  //#undef  OS_PERSISTENT
  //#define OS_PERSISTENT

  #undef  OS_USE_CSEM
  #undef  OS_USE_BSEM
  #undef  OS_USE_MSG
  #undef  OS_USE_MSGQ
  #undef  OS_USE_FLAGS
  #if   (OS_Lib_Type & OSL_EVENT)
    #define OS_USE_CSEM
    #define OS_USE_BSEM
    #define OS_USE_MSG
    #define OS_USE_MSGQ
    #define OS_USE_FLAGS
    #if defined(OS_PROTECT_ENABLE) && defined(OS_LIB)
      #undef  OS_USE_CSEM_I
      #undef  OS_USE_BSEM_I
      #undef  OS_USE_MSG_I
      #undef  OS_USE_MSGQ_I
      #undef  OS_USE_FLAGS_I
      #undef  OS_USE_RESUME_I
      //#undef  OS_USE_ACCEPT_MSGQ_I

      #define OS_USE_CSEM_I
      #define OS_USE_BSEM_I
      #define OS_USE_MSG_I
      #define OS_USE_MSGQ_I
      #define OS_USE_FLAGS_I
      #define OS_USE_RESUME_I
      //#define OS_USE_ACCEPT_MSGQ_I
    #endif
  #endif

#endif //ifndef OS_Lib_Type

#endif // _JA_LIBR_H
