// OS_TMR_TICK = 1000

#if defined(_PIC18_)                // PIC18 Hi-Tech
  PR2     = (OS_TMR_TICK/4) - 1;    // timer tick = 1000 instruction cycles
  INTCON  = 0xC0;
  #ifdef _MC_
    PIE1bits.TMR2IE  = 1;
    PIR1bits.TMR2IF  = 0;
  #else
    TMR2IE  = 1;
    TMR2IF  = 0;
  #endif
  T2CON   = 0x05;

#elif  defined(_PIC14)              // PIC16 Hi-Tech (14-bit)
  OPTION  = 0b00000001;             // timer tick = 1000 instruction cycles
  INTCON  = 0b11100000;

#elif  defined(_PIC12)              // PIC12 Hi-Tech (12-bit)
  OPTION  = 0xD2;                   // timer tick = 1000 instruction cycles
  TMR0    = 0;

#elif  defined(_AVR_)               // AVR IAR, AVR GCC
  //TCCR0A   =  (1 << CS01);        // timer tick = 2000 instruction cycles
  TCCR0    =  (1 << CS01);
  //TIMSK0   |= (1 << TOIE0);
  TIMSK    |= (1 << TOIE0);
  OS_Ena_Int();                     // enable interrupts

#elif  defined(_MSP_)               // MSP430 IAR
  TACCTL1_bit.CCIE = 1;             // it is enough of it only for C-Spy needs
  OS_Ena_Int();                     // adjust the timer settings for real work

#elif  defined(_51_)                // 8x51 Keil
  TMOD    = 0x00;                   // timer tick = 8K instruction cycles
  TCON    = 0x10;
  EA      = 1;
  ET0     = 1;

#elif  defined(_ARM_)
  OS_Ena_Int();                     // it is enough of it only for C-Spy needs
                                    // adjust the timer settings for real work
#elif defined(_DSPIC_)
  PR1     = OS_TMR_TICK - 1;        // timer tick = 1000 instruction cycles
  T1CON   = 0x8000; //0x8030;       // presc = 1 //presc = 256; ton = 1
  #ifdef _MC_
    _T1IP   = 0x4;
    _T1IE   = 1;
  #else
    T1IP   = 0x4;
    T1IE   = 1;
  #endif
  OS_Ena_Int();
#else
  #error prim_tmr
#endif
